@echo off
setlocal enabledelayedexpansion
echo. 
echo Dual VLC Transcoder - makes H.264 [.mp4] and WebM [.webm] videos 
echo ----------------------------------------------------------------

if "%2" == "" (
    echo.
    echo Usage:
    echo ------
    echo.
    echo %~df0 \path\to\sourcevideofile.avi \path\to\destination_name
    echo.
    echo      sourcevideofile can be nearly any video type--avi,wmv,mkv..etc.
    echo.
    echo      Don't specify the output extension, .mp4 and .webm will be appended.
    
    goto fin
)

REM ensure that these are set correctly in case we use the azure tool to upload.
reg query "HKLM\SOFTWARE\Classes\MIME\Database\Content Type\video/webm" > nul 2>&1 && goto do_mkv

REM if we need to put the entries in, we need to be elevated:
whoami /groups | find "S-1-16-12288" > nul || goto NEEDUAC

REG ADD "HKLM\SOFTWARE\Classes\MIME\Database\Content Type\video/webm" /v Extension /t REG_SZ /d ".webm"
REG ADD "HKLM\SOFTWARE\Classes\MIME\Database\Content Type\video/webm" /v CLSID /t REG_SZ /d "{cd3afa99-b84f-48f0-9393-7edc34128127}"

:do_mkv
reg query "HKLM\SOFTWARE\Classes\MIME\Database\Content Type\video/mkv" > nul  2>&1 && goto donereg

REM if we need to put the entries in, we need to be elevated:
whoami /groups | find "S-1-16-12288" > nul || goto NEEDUAC

REG ADD "HKLM\SOFTWARE\Classes\MIME\Database\Content Type\video/mkv" /v Extension /t REG_SZ /d ".mkv"
REG ADD "HKLM\SOFTWARE\Classes\MIME\Database\Content Type\video/mkv" /v CLSID /t REG_SZ /d "{cd3afa99-b84f-48f0-9393-7edc34128127}"

:donereg

FOR %%? IN ("%1") DO (
    if NOT exist %%~f? ( 
        echo.
        echo ERROR: 
        echo    File %%~f? does not exist!
        echo.
        goto fin:
    )
)


echo. 
echo Creating two video files:
echo. 
echo     Source
FOR %%? IN ("%1") DO (
    set /a sz=%%~z? / 1024 / 1024
    echo         %%~f?  : !sz! MB
    )
echo. 
echo     Destination: 
FOR %%? IN ("%2.mp4" "%2.webm") DO echo         %%~f?  
echo. 
echo ----------------------------------------------------------------

REM the mp4 transcode is much faster, we'll spin it out into the background
start "transcode" "C:\Program Files (x86)\VideoLAN\VLC\vlc.exe" %1 --sout "#transcode{vcodec=h264,vb=2000,scale=1,acodec=mp4a,ab=192,channels=2,samplerate=44100}:std{access=file,mux=mp4,dst=%2.mp4}"  vlc://quit

REM the batch file will wait for VLC to finish this one.
"C:\Program Files (x86)\VideoLAN\VLC\vlc.exe" %1 --sout "#transcode{vcodec=VP80,vb=2000,scale=1,acodec=vorbis,ab=192,channels=2,samplerate=44100}:std{access=file,mux=ffmpeg{mux=webm},dst=%2.webm}"  vlc://quit

REM extract the poster
"C:\Program Files (x86)\VideoLAN\VLC\vlc.exe" %1 --video-filter=scene --vout=dummy --aout=dummy --start-time=0 --stop-time=0.2  --scene-ratio=1 --scene-prefix=FRAME- --scene-path=.\ --scene-format=png  vlc://quit
ren FRAME-00001.png "%2.png"
erase FRAME-*.png


echo Done Transcoding Videos.
echo. 

FOR %%? IN ("%2.mp4" "%2.webm") DO (
    set /a sz=%%~z? / 1024 / 1024
    echo     %1 =^> %%~f?  : !sz! MB
    )
echo ----------------------------------------------------------------
echo. 
echo. 
goto fin

:NEEDUAC
echo.
echo ** ERROR **
echo.
echo You need to be an administrator to run this script the first time.
echo Please start the command prompt as administrator and try again.
echo.

:fin